module ModelToView (ModelToView(..),new)
    where

import View (View,onGrid)
import qualified View.Component.Grid as Grid
import qualified View.GridPage as GridPage

data ModelToView = ModelToView { numDataRows :: IO Int
                               , numDataColumns :: IO Int
                               , markAsSavedAs :: String -> IO ()
                               , markAsUnsaved :: IO ()
                               }

new :: View -> ModelToView
new view = ModelToView 
           { numDataRows = onGrid view Grid.numDataRows
           , numDataColumns = onGrid view Grid.numDataColumns
           , markAsSavedAs = GridPage.setCurrentCaption `flip` view
           , markAsUnsaved = GridPage.markAsUnsaved view
           }
