module View.Modes (formulaMode,gridMode)
    where

import qualified Graphics.UI.WX as WX
import qualified Graphics.UI.WXCore as WXC
import View (View,onGrid,formulaInput)
import CellCoordinate (CellCoord)

formulaMode :: CellCoord -> String -> View -> IO ()
formulaMode (row,col) value view = 
    onGrid view $ \grid -> do
      WXC.textCtrlSetValue (formulaInput view) value
      WXC.gridSelectBlock grid row col row col False
      WXC.windowEnable $ formulaInput view
      WX.focusOn $ formulaInput view

gridMode :: View -> IO ()
gridMode view = 
    onGrid view $ \grid -> do
      WXC.gridSelectBlock grid (-1) (-1) (-1) (-1) False
      WXC.windowDisable $ formulaInput view
      WX.focusOn grid
